<template>
    <table id="datatable-buttons" class="table table-striped table-bordered">
        <thead>
            <tr>
                <th>#</th>
                <th>Nombre</th>
                <th>Apellido</th>
                <th>E-mail</th>
                <th>Rol</th>
                <th>registro</th>
                <th>Status</th>
                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(user, index) in users" :key="user.id">
                <td>{{ index + 1 }}</td>
                <td>{{ user.firstname }}</td>
                <td>{{ user.lastname }}</td>
                <td>{{ user.email }}</td>
                <td v-if="role == 2">Administrativo</td>
                <td v-if="role == 10">Estudiante</td>
                <td>{{ user.created_at | formatDate }}</td>
                <td class="text-primary">
                    {{
                        user.email_verified_at ? "Verificado" : "No verificado"
                    }}
                </td>
                <td>
                    <div
                        class="tabledit-toolbar btn-toolbar"
                        style="text-align: left;"
                    >
                        <div
                            class="btn-group btn-group-sm"
                            style="float: none;"
                        >
                            <button
                                type="button"
                                class="tabledit-edit-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                v-bind:data-target="'#editModal' + user.id"
                            >
                                <span class="ti-pencil"></span></button
                            ><button
                                type="button"
                                class="tabledit-delete-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                v-bind:data-target="'#deleteModal' + user.id"
                            >
                                <span class="ti-trash"></span>
                            </button>
                        </div>
                    </div>
                </td>

                <!-- editar -->
                <div
                    class="modal fade"
                    v-bind:id="'editModal' + user.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'editModalLabel' + user.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="editModalLabel">
                                    Editar Usuario
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form
                                    v-bind:id="'form-' + user.id"
                                    method="POST"
                                    v-on:submit.prevent="updateUser(user)"
                                >
                                    <div
                                        v-if="error"
                                        id="errorAlert"
                                        class="alert alert-danger alert-dismissible fade show"
                                        role="alert"
                                    >
                                        <strong>Ohh no!</strong> {{ error }}.
                                        <button
                                            type="button"
                                            class="close"
                                            v-on:click.prevent="closeAlert()"
                                            aria-label="Close"
                                        >
                                            <span aria-hidden="true"
                                                >&times;</span
                                            >
                                        </button>
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            placeholder="Ingrese el nombre"
                                            class="form-control "
                                            name="firstname"
                                            v-model="user.firstname"
                                            required
                                            autocomplete="fisrtname"
                                            autofocus
                                        />
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            placeholder="Ingrese el apellido"
                                            class="form-control "
                                            name="lastname"
                                            v-model="user.lastname"
                                            required
                                            autocomplete="lastname"
                                            autofocus
                                        />
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="email"
                                            placeholder="Ingrese el correo electrónico"
                                            class="form-control"
                                            name="email"
                                            v-model="user.email"
                                            required
                                            autocomplete="email"
                                        />
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="password"
                                            placeholder="Ingrese nueva contraseña"
                                            class="form-control"
                                            name="password"
                                            v-model="user.password"
                                            required
                                            autocomplete="new-password"
                                        />
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="password"
                                            placeholder="Reingrese la nueva contraseña"
                                            class="form-control"
                                            name="password_confirmation"
                                            v-model="user.password_confirmation"
                                            required
                                            autocomplete="new-password"
                                        />
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Cerrar
                                </button>
                                <button
                                    v-on:click.prevent="updateUser(user)"
                                    type="button"
                                    class="btn btn-primary"
                                >
                                    Guardar cambios
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- eliminar -->
                <div
                    class="modal fade"
                    v-bind:id="'deleteModal' + user.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'deleteModalLabel' + user.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header bg-danger">
                                <h5
                                    class="modal-title "
                                    v-bind:id="'deleteModalLabel' + user.id"
                                >
                                    Eliminar usuario
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <p class="text-muted">
                                    ¿Seguro desea eliminar al usuario
                                    {{
                                        user.role == 2
                                            ? "Administrativo"
                                            : "Estudiante"
                                    }}
                                    <b
                                        >{{ user.firstname }}
                                        {{ user.lastname }}</b
                                    >?
                                </p>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Cancelar
                                </button>
                                <button
                                    type="button"
                                    class="btn btn-danger"
                                    v-on:click.prevent="deleteUser(user.id)"
                                >
                                    Eliminar Usuario
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </tr>
        </tbody>
        <!-- crear usuario -->
        <div
            class="modal fade"
            id="crearModal"
            tabindex="-1"
            role="dialog"
            aria-labelledby="crearModalLabel"
            aria-hidden="true"
        >
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="crearModalLabel">
                            Agregar nuevo
                            {{ role == 10 ? "estudiante" : "administrador" }}
                        </h5>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                            aria-label="Close"
                        >
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form method="POST">
                            <!-- Alerta de error -->
                            <div
                                v-if="error"
                                id="errorAlert"
                                class="alert alert-danger alert-dismissible fade show"
                                role="alert"
                            >
                                <strong>Ohh no!</strong> {{ error }}.
                                <button
                                    type="button"
                                    class="close"
                                    v-on:click.prevent="closeAlert()"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <!-- fin de error -->
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Ingrese el nombre"
                                    class="form-control "
                                    name="firstname"
                                    v-model="newUser.firstname"
                                    required
                                    autocomplete="fisrtname"
                                    autofocus
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Ingrese el apellido"
                                    class="form-control "
                                    name="lastname"
                                    v-model="newUser.lastname"
                                    required
                                    autocomplete="lastname"
                                    autofocus
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    type="email"
                                    placeholder="Ingrese el correo electrónico"
                                    class="form-control"
                                    name="email"
                                    v-model="newUser.email"
                                    required
                                    autocomplete="email"
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    type="password"
                                    placeholder="Ingrese nueva contraseña"
                                    class="form-control"
                                    name="password"
                                    v-model="newUser.password"
                                    required
                                    autocomplete="new-password"
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    type="password"
                                    placeholder="Reingrese la nueva contraseña"
                                    class="form-control"
                                    name="password_confirmation"
                                    v-model="newUser.password_confirmation"
                                    required
                                    autocomplete="new-password"
                                />
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button
                            type="button"
                            class="btn btn-secondary"
                            data-dismiss="modal"
                        >
                            Cerrar
                        </button>
                        <button
                            v-on:click.prevent="createUser()"
                            type="button"
                            class="btn btn-primary"
                        >
                            Crear
                            {{ role == 10 ? "estudiante" : "Administrador" }}
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <!-- fin crear usuario -->
    </table>
</template>

<script>
export default {
    props: ["role"],
    created() {
        this.get();
    },
    mounted() {
        
    },
    data() {
        return {
            items: this.role,
            users: [
                {
                    firstname: "",
                    lastname: "",
                    email: "",
                    created_at: "",
                    email_verified_at: ""
                }
            ],
            newUser: {
                firstname: "",
                lastname: "",
                email: "",
                password: "",
                password_confirmation: ""
            },
            error: ""
        };
    },
    methods: {
        get: function() {
            var url = "/api/users";
            axios
                .get(url)
                .then(res => {
                    
                    this.users = res.data.filter(
                        user => user.role == this.role
                    );
                    
                })
                .catch(err => {
                    console.error(err);
                });
        },
        deleteUser: function(item) {
            var url = "/api/users/" + item;
            axios
                .delete(url)
                .then(res => {
                    $("#deleteModal" + item).modal("toggle");
                    $(".modal-backdrop").remove();
                    this.get();
                })
                .catch(err => {
                    console.log(err);
                });
        },
        updateUser: function(user) {
            var url = "/api/users/" + user.id;
            if (user.password && user.password.length < 8) {
                this.error = "La contraseña debe se mayor a 8 caracteres";
            } else {
                axios
                    .put(url, user)
                    .then(res => {
                        
                        if (res.data.error) {
                            this.error = res.data.error;
                            $("#errorAlert").show();
                        } else {
                            $("#editModal" + user.id).modal("toggle");
                            $(".modal-backdrop").remove();
                            this.get();
                        }
                    })
                    .catch(err => {
                        console.log(err);
                    });
            }
        },
        createUser: function() {
            if (
                !this.newUser.password &&
                !this.newUser.firstname &&
                !this.newUser.lastname &&
                !this.newUser.email &&
                !this.newUser.password_confirmation
            ) {
                this.error =
                    "Debe rellenar todos los campos necesarios para continuar creando al nuevo usuario.";
            } else if (this.newUser.password.length < 8) {
                this.error =
                    "La contraseña ingresada no cumple con los requisitos minimos necesarios de seguridad.";
            } else if (
                this.newUser.password != this.newUser.password_confirmation
            ) {
                this.error =
                    "Las contraseñas ingresadas no coincide con la verificación.";
            } else {
                var url = "/api/users";
                this.newUser.role = this.role;
                axios
                    .post(url, this.newUser)
                    .then(res => {
                        
                        if (res.data.error) {
                            this.error = res.data.error;
                        } else {
                            console.log(res);
                            $("#crearModal").modal("toggle");
                            $(".modal-backdrop").remove();
                            this.get();
                        }
                    })
                    .catch(err => {
                        console.log(err);
                    });
            }
        },
        closeAlert: function() {
            this.error = "";
        }
    }
};
</script>
